/*
PAYMENTS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package paymentsapi

import (
	"encoding/json"
	"time"
)

// checks if the PaypalConfiguration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PaypalConfiguration{}

// PaypalConfiguration struct for PaypalConfiguration
type PaypalConfiguration struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	ApiUrl string `json:"api_url"`
	ClientId string `json:"client_id"`
	WebhookId *string `json:"webhook_id,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewPaypalConfiguration instantiates a new PaypalConfiguration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPaypalConfiguration(id string, organizationId string, apiUrl string, clientId string, createdAt time.Time, updatedAt time.Time) *PaypalConfiguration {
	this := PaypalConfiguration{}
	this.Id = id
	this.OrganizationId = organizationId
	this.ApiUrl = apiUrl
	this.ClientId = clientId
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewPaypalConfigurationWithDefaults instantiates a new PaypalConfiguration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPaypalConfigurationWithDefaults() *PaypalConfiguration {
	this := PaypalConfiguration{}
	return &this
}

// GetId returns the Id field value
func (o *PaypalConfiguration) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *PaypalConfiguration) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *PaypalConfiguration) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *PaypalConfiguration) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetApiUrl returns the ApiUrl field value
func (o *PaypalConfiguration) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *PaypalConfiguration) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetClientId returns the ClientId field value
func (o *PaypalConfiguration) GetClientId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetClientIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ClientId, true
}

// SetClientId sets field value
func (o *PaypalConfiguration) SetClientId(v string) {
	o.ClientId = v
}

// GetWebhookId returns the WebhookId field value if set, zero value otherwise.
func (o *PaypalConfiguration) GetWebhookId() string {
	if o == nil || IsNil(o.WebhookId) {
		var ret string
		return ret
	}
	return *o.WebhookId
}

// GetWebhookIdOk returns a tuple with the WebhookId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetWebhookIdOk() (*string, bool) {
	if o == nil || IsNil(o.WebhookId) {
		return nil, false
	}
	return o.WebhookId, true
}

// HasWebhookId returns a boolean if a field has been set.
func (o *PaypalConfiguration) HasWebhookId() bool {
	if o != nil && !IsNil(o.WebhookId) {
		return true
	}

	return false
}

// SetWebhookId gets a reference to the given string and assigns it to the WebhookId field.
func (o *PaypalConfiguration) SetWebhookId(v string) {
	o.WebhookId = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *PaypalConfiguration) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *PaypalConfiguration) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *PaypalConfiguration) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *PaypalConfiguration) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *PaypalConfiguration) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o PaypalConfiguration) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PaypalConfiguration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["client_id"] = o.ClientId
	if !IsNil(o.WebhookId) {
		toSerialize["webhook_id"] = o.WebhookId
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullablePaypalConfiguration struct {
	value *PaypalConfiguration
	isSet bool
}

func (v NullablePaypalConfiguration) Get() *PaypalConfiguration {
	return v.value
}

func (v *NullablePaypalConfiguration) Set(val *PaypalConfiguration) {
	v.value = val
	v.isSet = true
}

func (v NullablePaypalConfiguration) IsSet() bool {
	return v.isSet
}

func (v *NullablePaypalConfiguration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePaypalConfiguration(val *PaypalConfiguration) *NullablePaypalConfiguration {
	return &NullablePaypalConfiguration{value: val, isSet: true}
}

func (v NullablePaypalConfiguration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePaypalConfiguration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


